//--------------------------------------------------------------------//
// t@Cǂݍ

// f[^t@Cǂݍ
// fileName - f[^t@C
// func - ǂݍ݊֐
function readDataFile(fileName,func){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      func(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// f[^ǂݍ
// s - f[^̃Xg
function readStarsData(s){
  var vmag;
  for(var i=0;i<s.length;i++){
    var ss=s[i].trim().replace(/\t/g,' ').split(/\s+/);
    var keyWord=ss[0].toLowerCase();
    if((keyWord=="epoch") && (ss.length>=2)){		// f̊EX
      epoch=parseFloat(ss[1]);
    }
    else if((keyWord=="earth") && (ss.length>=14)){	// n
      starsModel.addEarth(getPlanet(ss));
    }
    else if((keyWord=="planet") && (ss.length>=14)){	// f
      starsModel.addPlanet(getPlanet(ss));
    }
    else if((keyWord=="fixedstar") && (ss.length>=10)){	// P
      var bayer=ss[3],number=parseInt(ss[4]);
      if((bayer=='null') && (number>0)){
      	bayer=number.toString(10);
      }
      vmag=parseFloat(ss[8]);
      var r=vmagToRad(vmag);
      starsModel.addStar
      	(new FixedStar(ss[1],ss[2],ss[5],r,r,
      	      	       readRa1(ss[6]),readDe1(ss[7]),vmag,
      	      	       colorIndexBV(Number(ss[9])),bayer));
    }
    else if((keyWord=="nebula") && (ss.length>=10)){	// _
      var type=ss[4].toLowerCase();
      var r1=parseInt(ss[7]),r2=parseInt(ss[8]);
      vmag=parseFloat(ss[9]);
      if(type===BRINEB){
      	vmag=5.0-0.04*Math.sqrt(r1*r2);
      	r1=Math.max(parseInt(0.02*r1+0.5),1);
      	r2=Math.max(parseInt(0.02*r2+0.5),1);
      }
      else if(type===GALAXY){
      	r1=Math.max(parseInt(0.02*r1+0.5),1);
      	r2=Math.max(parseInt(0.02*r2+0.5),1);
      }
      else{
      	r1=vmagToRad(vmag);
      	r2=r1;
      }
      starsModel.addStar
      	(new FixedStar(ss[1],ss[2],ss[3],r1,r2,readRa2(ss[5]),
      	      	       readDe2(ss[6]),vmag,nebulaColor(type,vmag),
      	      	       null));
    }
    else if(ss.length>=4){				// 
      var count=parseInt(ss[3]);
      var connect=[];
      for(var j=0;j<count;j++){
      	connect[j]=[ss[2*j+4],ss[2*j+5]];
      }
      starsModel.addConstellation
      	(new Constellation(ss[0],ss[1],ss[2],connect));
    }
  }
  starsModel.setConstellationName();
  starsModel.calculateCoordinates();
}

// ff[^Ԃ
// ss - f[^
function getPlanet(ss){
  var type=ss[1].toLowerCase();
  var lofp=TO_RADIAN*Number(ss[8]);
  var lofp2=0;
  var ii=9;
  if(type==SATERITE){
    lofp2=TO_RADIAN*Number(ss[9]);
    ii++;
  }
  var lofan=TO_RADIAN*Number(ss[ii]);
  ii++;
  var lofan2=0;
  if(type==SATERITE){
    lofan2=TO_RADIAN*Number(ss[ii]);
    ii++;
  }
  var inc=TO_RADIAN*Number(ss[ii]);
  var meanl=TO_RADIAN*Number(ss[ii+1]);
  var period=Number(ss[ii+2]);
  var pinv=0;
  if(period!==0){
    if((type==INNER_PLANET) || (type==OUTER_PLANET)){
      pinv=2*Math.PI/(365.25*period);
    }
    else{
      pinv=2*Math.PI/period;
    }
  }
  return new Planet(ss[2],type,parseInt(ss[4]),parseInt(ss[5]),
      	      	    Number(ss[6]),Number(ss[7]),lofp,lofp2,
      	      	    lofan,lofan2,inc,meanl,pinv,
      	      	    TO_RADIAN*Number(ss[ii+3]),ss[3]);
}

// ԌoԂ
// s - Ԍo\
function readRa1(s){
  var idh=s.indexOf('h'),idm=s.indexOf('m'),ids=s.indexOf('s');
  var rah=parseInt(s.substring(0,idh));
  var ram=parseInt(s.substring(idh+1,idm))/60;
  var ras=parseFloat(s.substring(idm+1,ids))/3600;
  return Math.PI/12*(rah+ram+ras);
}

// ԌoԂ
// s - Ԍo\
function readRa2(s){
  var idh=s.indexOf('h'),idm=s.indexOf('m');
  var rah=parseInt(s.substring(0,idh));
  var ram=parseInt(s.substring(idh+1,idm))/60;
  return Math.PI/12*(rah+ram);
}

// Ԉ܂Ԃ
// s - Ԉ܂\
function readDe1(s){
  var idd=s.indexOf('d'),idm=s.indexOf('m'),ids=s.indexOf('s');
  var ded=parseInt(s.substring(1,idd));
  var dem=parseInt(s.substring(idd+1,idm))/60;
  var des=parseFloat(s.substring(idm+1,ids))/3600;
  var de=ded+dem+des;
  if(s.charAt(0)==='-') de=-de;
  return TO_RADIAN*de;
}

// Ԉ܂Ԃ
// s - Ԉ܂\
function readDe2(s){
  var idd=s.indexOf('d'),idm=s.indexOf('m');
  var ded=parseInt(s.substring(1,idd));
  var dem=parseInt(s.substring(idd+1,idm))/60;
  var de=ded+dem;
  if(s.charAt(0)==='-') de=-de;
  return TO_RADIAN*de;
}

// ̕\aԂ
// vm - 
function vmagToRad(vm){
  return Math.max(parseInt(4.5-vm),1);
}

// Cݐf[^ǂݍ
// s - f[^̃Xg
function readMapData(s){
  var list=globe.list;
  list.length=0;
  var row=0,mm=-1,aa=0,bb=0,name='',area=0,block=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>=2){
      var p=new GlobePoint(Number(ss[0]),Number(ss[1]));
      if(block>0){
      	list[mm][aa][bb]=p;
      	bb++;
      	if(bb==block){
      	  block=0;
      	  if(aa+1==area){
      	    area=0;
      	  }
      	}
      }
    }
    else if(ss.length==1){
      if(isNaN(ss[0])){
      	name=ss[0];
      }
      else if(ss[0]===''){
      }
      else if(area===0){
      	area=parseInt(ss[0]);
      	mm++;
      	list[mm]=[];
      	aa=-1;
      }
      else{
      	block=parseInt(ss[0]);
      	aa++;
      	list[mm][aa]=[];
      	bb=0;
      }
    }
    row++;
  }
}
